"use strict";

module.exports = {
    builtins: {
        Symbol: "symbol",
        Promise: "promise",
        Map: "map",
        WeakMap: "weak-map",
        Set: "set",
        WeakSet: "weak-set",
        Observable: "observable",
        setImmediate: "set-immediate",
        clearImmediate: "clear-immediate",
        Reflect: "reflect",
        Proxy: "proxy"
    },

    methods: {
        Array: {
            from: "array/from",
            isArray: "array/is-array",
            of: "array/of",
            observe: "array/observe",
            prototype: {
                copyWithin: "array/copy-within",
                entries: "array/entries",
                fill: "array/fill",
                find: "array/find",
                findIndex: "array/find-index",
                includes: "array/includes",
                keys: "array/keys",
                values: "array/values"
            }
        },

        JSON: {
            // stringify: "json/stringify",
            // parse: "json/parse"
        },

        Object: {
            assign: "object/assign",
            entries: "object/entries",
            getOwnPropertySymbols: "object/get-own-property-symbols",
            is: "object/is",
            observe: "object/observe",
            setPrototypeOf: "object/set-prototype-of",
            values: "object/values"
        },

        RegExp: {
            escape: "regexp/escape" // deprecated
        },

        Math: {
            acosh: "math/acosh",
            asinh: "math/asinh",
            atanh: "math/atanh",
            cbrt: "math/cbrt",
            clz32: "math/clz32",
            cosh: "math/cosh",
            expm1: "math/expm1",
            fround: "math/fround",
            hypot: "math/hypot",
            imul: "math/imul",
            log10: "math/log10",
            log1p: "math/log1p",
            log2: "math/log2",
            sign: "math/sign",
            sinh: "math/sinh",
            tanh: "math/tanh",
            trunc: "math/trunc",
            iaddh: "math/iaddh",
            isubh: "math/isubh",
            imulh: "math/imulh",
            umulh: "math/umulh"
        },

        String: {
            fromCodePoint: "string/from-code-point",
            raw: "string/raw",
            prototype: {
                anchor: "string/anchor",
                big: "string/big",
                blink: "string/blink",
                bold: "string/bold",
                charPointAt: "string/char-point-at",
                codePointAt: "string/code-point-at",
                endsWith: "string/ends-with",                
                fixed: "string/fixed",
                fontcolor: "string/fontcolor",
                fontsize: "string/fontsize",
                includes: "string/includes",
                italics: "string/italics",
                link: "string/link",
                normalize: "string/normalize",
                repeat: "string/repeat",
                small: "string/small",
                startsWith: "string/starts-with",
                strike: "string/strike",
                sub: "string/sub",
                sup: "string/sup"
            }
        },

        Number: {
            parseFloat: "number/parse-float",
            parseInt: "number/parse-int",
            EPSILON: "number",
            isFinite: "number/is-finite",
            isInteger: "number/is-integer",
            isNaN: "number/is-nan",
            isSafeInteger: "number/is-safe-integer"
        },

        Error: {
            isError: "error/is-error" // deprecated
        },

        Date: {
            // now: "date/now" // temporary disabled
        },

        Function: {
            
        }
    }
};